Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.Designer.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.Designer.cs	(revision 6675)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.Designer.cs	(revision 6675)
@@ -0,0 +1,155 @@
+﻿namespace HeuristicLab.Optimization.Views {
+  partial class RunCollectionModificationEvaluatorView {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.evaluateButton = new System.Windows.Forms.Button();
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.runsTabPage = new System.Windows.Forms.TabPage();
+      this.runCollectionViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.modifiersTabPage = new System.Windows.Forms.TabPage();
+      this.modifiersViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.tabControl.SuspendLayout();
+      this.runsTabPage.SuspendLayout();
+      this.modifiersTabPage.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // nameTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      this.nameTextBox.Size = new System.Drawing.Size(419, 20);
+      // 
+      // infoLabel
+      // 
+      this.infoLabel.Location = new System.Drawing.Point(483, 3);
+      // 
+      // evaluateButton
+      // 
+      this.evaluateButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.evaluateButton.Location = new System.Drawing.Point(6, 266);
+      this.evaluateButton.Name = "evaluateButton";
+      this.evaluateButton.Size = new System.Drawing.Size(75, 23);
+      this.evaluateButton.TabIndex = 4;
+      this.evaluateButton.Text = "&Evaluate";
+      this.evaluateButton.UseVisualStyleBackColor = true;
+      this.evaluateButton.Click += new System.EventHandler(this.evaluateButton_Click);
+      // 
+      // tabControl
+      // 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.runsTabPage);
+      this.tabControl.Controls.Add(this.modifiersTabPage);
+      this.tabControl.Location = new System.Drawing.Point(3, 26);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(496, 318);
+      this.tabControl.TabIndex = 5;
+      // 
+      // runsTabPage
+      // 
+      this.runsTabPage.Controls.Add(this.runCollectionViewHost);
+      this.runsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.runsTabPage.Name = "runsTabPage";
+      this.runsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.runsTabPage.Size = new System.Drawing.Size(488, 292);
+      this.runsTabPage.TabIndex = 0;
+      this.runsTabPage.Text = "Runs";
+      this.runsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // runCollectionViewHost
+      // 
+      this.runCollectionViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.runCollectionViewHost.Caption = "View";
+      this.runCollectionViewHost.Content = null;
+      this.runCollectionViewHost.Enabled = false;
+      this.runCollectionViewHost.Location = new System.Drawing.Point(6, 6);
+      this.runCollectionViewHost.Name = "runCollectionViewHost";
+      this.runCollectionViewHost.ReadOnly = false;
+      this.runCollectionViewHost.Size = new System.Drawing.Size(476, 280);
+      this.runCollectionViewHost.TabIndex = 0;
+      this.runCollectionViewHost.ViewsLabelVisible = true;
+      this.runCollectionViewHost.ViewType = null;
+      // 
+      // modifiersTabPage
+      // 
+      this.modifiersTabPage.Controls.Add(this.modifiersViewHost);
+      this.modifiersTabPage.Controls.Add(this.evaluateButton);
+      this.modifiersTabPage.Location = new System.Drawing.Point(4, 22);
+      this.modifiersTabPage.Name = "modifiersTabPage";
+      this.modifiersTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.modifiersTabPage.Size = new System.Drawing.Size(488, 292);
+      this.modifiersTabPage.TabIndex = 1;
+      this.modifiersTabPage.Text = "Modifiers";
+      this.modifiersTabPage.UseVisualStyleBackColor = true;
+      // 
+      // modifiersViewHost
+      // 
+      this.modifiersViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.modifiersViewHost.Caption = "View";
+      this.modifiersViewHost.Content = null;
+      this.modifiersViewHost.Enabled = false;
+      this.modifiersViewHost.Location = new System.Drawing.Point(6, 6);
+      this.modifiersViewHost.Name = "modifiersViewHost";
+      this.modifiersViewHost.ReadOnly = false;
+      this.modifiersViewHost.Size = new System.Drawing.Size(476, 254);
+      this.modifiersViewHost.TabIndex = 0;
+      this.modifiersViewHost.ViewsLabelVisible = true;
+      this.modifiersViewHost.ViewType = null;
+      // 
+      // RunCollectionModificationEvaluatorView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.Controls.Add(this.tabControl);
+      this.Name = "RunCollectionModificationEvaluatorView";
+      this.Size = new System.Drawing.Size(502, 347);
+      this.Controls.SetChildIndex(this.tabControl, 0);
+      this.Controls.SetChildIndex(this.infoLabel, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.tabControl.ResumeLayout(false);
+      this.runsTabPage.ResumeLayout(false);
+      this.modifiersTabPage.ResumeLayout(false);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button evaluateButton;
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage runsTabPage;
+    private MainForm.WindowsForms.ViewHost runCollectionViewHost;
+    private System.Windows.Forms.TabPage modifiersTabPage;
+    private MainForm.WindowsForms.ViewHost modifiersViewHost;
+  }
+}
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.cs	(revision 6675)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionModificationEvaluatorView.cs	(revision 6675)
@@ -0,0 +1,83 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Optimization.Views {
+
+  [View("RunCollection Calculator View")]
+  [Content(typeof(RunCollectionModificationEvaluator), IsDefaultView = true)]
+  public sealed partial class RunCollectionModificationEvaluatorView : NamedItemView {
+
+    public new RunCollectionModificationEvaluator Content {
+      get { return (RunCollectionModificationEvaluator)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public RunCollectionModificationEvaluatorView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.RunCollectionParameter.ValueChanged -= new EventHandler(RunCollection_Changed);
+      Content.ModifiersParameter.ValueChanged -= new EventHandler(Modifiers_Changed);
+      base.DeregisterContentEvents();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.RunCollectionParameter.ValueChanged += new EventHandler(RunCollection_Changed);
+      Content.ModifiersParameter.ValueChanged += new EventHandler(Modifiers_Changed);
+    }
+
+    #region Event Handlers (Content)
+    private void RunCollection_Changed(object sender, EventArgs args) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(RunCollection_Changed), sender, args);
+      else
+        runCollectionViewHost.Content = Content.RunCollection;
+    }
+    private void Modifiers_Changed(object sender, EventArgs args) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Modifiers_Changed), sender, args);
+      else
+        modifiersViewHost.Content = Content.Modifiers;
+    }
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        runCollectionViewHost.Content = null;
+        modifiersViewHost.Content = null;
+      } else {
+        runCollectionViewHost.Content = Content.RunCollection;
+        modifiersViewHost.Content = Content.Modifiers;
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      evaluateButton.Enabled = Content != null;
+    }
+
+    #region Event Handlers (child controls)
+    private void evaluateButton_Click(object sender, EventArgs e) {
+      evaluateButton.Enabled = false;
+      var worker = new BackgroundWorker();
+      worker.DoWork += (s, a) => Content.Evaluate();
+      worker.RunWorkerCompleted += (s, a) => { evaluateButton.Enabled = Content != null; };
+      worker.RunWorkerAsync();
+    }        
+    #endregion
+
+  }
+}
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionTypeCompatibilityConstraintView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionTypeCompatibilityConstraintView.cs	(revision 6674)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionTypeCompatibilityConstraintView.cs	(revision 6675)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Optimization.Views {
   [Content(typeof(RunCollectionTypeCompatibilityConstraint), true)]
-  public partial class RunCollectionTypeCompatibilityConstraintView : RunCollectionConstraintView {
+  public partial class RunCollectionTypeCompatibilityConstraintView : RunCollectionColumnConstraintView {
     public RunCollectionTypeCompatibilityConstraintView() {
       InitializeComponent();
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 6674)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 6675)
@@ -98,4 +98,8 @@
         }
       }
+      var modifierMenuItem = new ToolStripMenuItem();
+      modifierMenuItem.Text = "Modify RunCollection";
+      modifierMenuItem.Click += ModifierMenuItem_OnClick;
+      analyzeRunsToolStripDropDownButton.DropDownItems.Add(modifierMenuItem);
     }
 
@@ -336,4 +340,9 @@
       }
     }
+    private void ModifierMenuItem_OnClick(object sender, EventArgs args) {
+      var modifier = new RunCollectionModificationEvaluator();
+      modifier.RunCollection.AddRange(Content.Select(r => (IRun)r.Clone()));
+      MainFormManager.MainForm.ShowContent(modifier);
+    }
     private void removeButton_Click(object sender, EventArgs e) {
       if (itemsListView.SelectedItems.Count > 0) {
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/Calculator.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/Calculator.cs	(revision 6675)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/Calculator.cs	(revision 6675)
@@ -0,0 +1,106 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Text.RegularExpressions;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System.Globalization;
+
+namespace HeuristicLab.Optimization {  
+    
+  [StorableClass]
+  public class Calculator : IDeepCloneable {
+
+    #region Fields & Properties
+    
+    private List<string> tokens;
+
+    [Storable]
+    public string Formula {
+      get { return string.Join(" ", tokens); }
+      set { tokens = Tokenize(value).ToList(); }
+    }
+
+    private static readonly Regex TokenRegex = new Regex(@"[a-zA-Z0-9._]+|""([^""]|\"")+""|[-+*/^]|log");    
+
+    #endregion
+
+    #region Construction & Cloning
+
+    [StorableConstructor]
+    protected Calculator(bool deserializing) { }
+    public Calculator() { }
+    public Calculator(Calculator original, Cloner cloner) {
+      this.tokens = original.tokens.ToList();
+    }
+    public IDeepCloneable Clone(Cloner cloner) {
+      return new Calculator(this, cloner);
+    }
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+    #endregion
+
+    public IEnumerable<string> Tokenize(string s) {
+      return TokenRegex.Matches(s).Cast<Match>().Select(m => m.Value);
+    }
+
+    private double GetVariableValue(IDictionary<string, IItem> variables, string name) {
+      if (variables.ContainsKey(name)) {
+        var item = variables[name];
+        var intValue = item as IntValue;
+        if (intValue != null) {
+          return intValue.Value;
+        } else {
+          var doubleValue = item as DoubleValue;
+          if (doubleValue != null)
+            return doubleValue.Value;
+          else
+            throw new InvalidOperationException("Non numerical argument");
+        }
+      } else {
+        throw new InvalidOperationException(string.Format("variable \"{0}\" not found", name));
+      }
+    }
+
+    public IItem GetValue(IDictionary<string, IItem> variables) {
+      var stack = new Stack<double>();
+      Action<Func<double, double, double>> binf = op => {
+        var b = stack.Pop();
+        stack.Push(op(stack.Pop(), b));
+      };
+      try {
+        foreach (var token in tokens) {
+          double d;
+          if (double.TryParse(token,
+                NumberStyles.AllowDecimalPoint |
+              NumberStyles.AllowExponent |
+              NumberStyles.AllowLeadingSign, CultureInfo.InvariantCulture, out d)) {
+            stack.Push(d);
+          } else if (token.StartsWith("\"")) {
+            stack.Push(GetVariableValue(variables, token.Substring(1, token.Length - 2).Replace(@"\""", @"""")));
+          } else {
+            switch (token) {
+              case "log": stack.Push(Math.Log(stack.Pop())); break;
+              case "+": binf((x, y) => x + y); break;
+              case "-": binf((x, y) => x - y); break;
+              case "*": binf((x, y) => x * y); break;
+              case "/": binf((x, y) => x / y); break;
+              case "^": binf(Math.Pow); break;
+              default: stack.Push(GetVariableValue(variables, token)); break;
+            }
+          }
+        }
+      } catch (InvalidOperationException x) {
+        return new StringValue(string.Format("Calculation Failed: {0}", x.Message));
+      }
+      if (stack.Count != 1)
+        return new StringValue("Invalid final evaluation stack size != 1");
+      return new DoubleValue(stack.Pop());      
+    }    
+  }
+}
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6674)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 6675)
@@ -111,7 +111,10 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="RunCollectionValueRemover.cs" />
+    <Compile Include="IRunCollectionModifier.cs" />
     <None Include="HeuristicLabOptimizationPlugin.cs.frame" />
     <Compile Include="Algorithms\Algorithm.cs" />
     <Compile Include="BatchRun.cs" />
+    <Compile Include="Calculator.cs" />
     <Compile Include="Interfaces\IDiscreteDoubleMatrixModifier.cs" />
     <Compile Include="Algorithms\HeuristicOptimizationEngineAlgorithm.cs" />
@@ -136,6 +139,10 @@
     <Compile Include="Interfaces\ISingleObjectiveHeuristicOptimizationProblem.cs" />
     <Compile Include="Problems\Problem.cs" />
+    <Compile Include="RunCollectionFormulaModifer.cs" />
+    <Compile Include="RunCollectionFuzzifier.cs" />
+    <Compile Include="RunCollectionModificationEvaluator.cs" />
     <Compile Include="RunCollectionConstraints\RunCollectionComparisonConstraint.cs" />
     <Compile Include="RunCollectionConstraints\RunCollectionConstraintCollection.cs" />
+    <Compile Include="RunCollectionConstraints\RunCollectionContentConstraint.cs" />
     <Compile Include="RunCollectionConstraints\RunCollectionTypeCompatiblityConstraint.cs" />
     <Compile Include="RunCollectionConstraints\RunCollectionEqualityConstraint.cs" />
@@ -244,4 +251,5 @@
     </BootstrapperPackage>
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/IRunCollectionModifier.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/IRunCollectionModifier.cs	(revision 6675)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/IRunCollectionModifier.cs	(revision 6675)
@@ -0,0 +1,11 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization {
+  public interface IRunCollectionModifier : IItem {    
+    void Modify(List<IRun> runs);
+  }
+}
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/IRunCollectionConstraint.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/IRunCollectionConstraint.cs	(revision 6674)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/IRunCollectionConstraint.cs	(revision 6675)
@@ -26,4 +26,7 @@
   public interface IRunCollectionConstraint : IConstraint {
     new RunCollection ConstrainedValue { get; set; }
+  }
+
+  public interface IRunCollectionColumnConstraint : IRunCollectionConstraint {
     string ConstraintColumn { get; set; }
     event EventHandler ConstraintColumnChanged;
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionComparisonConstraint.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionComparisonConstraint.cs	(revision 6674)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionComparisonConstraint.cs	(revision 6675)
@@ -30,5 +30,5 @@
   [StorableClass]
   [Item("RunCollectionComparisonConstraint", "A constraint which compares the members of the contained runs with the constraint data.")]
-  public class RunCollectionComparisonConstraint : ComparisonConstraint, IRunCollectionConstraint {
+  public class RunCollectionComparisonConstraint : ComparisonConstraint, IRunCollectionColumnConstraint {
     [StorableConstructor]
     protected RunCollectionComparisonConstraint(bool deserializing) : base(deserializing) { }
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionContentConstraint.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionContentConstraint.cs	(revision 6675)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionContentConstraint.cs	(revision 6675)
@@ -0,0 +1,107 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization {
+  [StorableClass]
+  public class RunCollectionContentConstraint : Constraint, IRunCollectionConstraint {
+    public new RunCollection ConstrainedValue {
+      get { return (RunCollection)base.ConstrainedValue; }
+      set { base.ConstrainedValue = value; }
+    }
+
+    public new ItemSet<IRun> ConstraintData {
+      get { return (ItemSet<IRun>)base.ConstraintData; }
+      set { base.ConstraintData = value; }
+    }
+
+    public override IEnumerable<ConstraintOperation> AllowedConstraintOperations {
+      get { return new List<ConstraintOperation>() { ConstraintOperation.Equal }; }
+    }
+
+    [StorableConstructor]
+    protected RunCollectionContentConstraint(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterConstraintDataEvents();
+    }
+    protected RunCollectionContentConstraint(RunCollectionContentConstraint original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterConstraintDataEvents();
+    }
+    public override IDeepCloneable Clone(Cloner cloner) { return new RunCollectionContentConstraint(this, cloner); }
+
+    public RunCollectionContentConstraint()
+      : base() {
+      ConstraintData = new ItemSet<IRun>();
+    }
+    public RunCollectionContentConstraint(RunCollection constrainedValue, IObservableSet<IRun> constraintData)
+      : base(constrainedValue, ConstraintOperation.Equal, constraintData) {
+    }
+    public RunCollectionContentConstraint(RunCollection constrainedValue, IObservableSet<IRun> constraintData, bool active)
+      : base(constrainedValue, ConstraintOperation.Equal, constraintData, active) {
+    }
+
+    protected override void OnConstraintDataChanged() {
+      RegisterConstraintDataEvents();
+      base.OnConstraintDataChanged();
+    }
+    private void RegisterConstraintDataEvents() {
+      if (ConstraintData != null) {
+        ConstraintData.ItemsAdded += new CollectionItemsChangedEventHandler<IRun>(ConstraintData_ItemsAdded);
+        ConstraintData.ItemsRemoved += new CollectionItemsChangedEventHandler<IRun>(ConstraintData_ItemsRemoved);
+        ConstraintData.CollectionReset += new CollectionItemsChangedEventHandler<IRun>(ConstraintData_CollectionReset);
+      }
+    }
+    private void ConstraintData_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IRun> e) {
+      base.OnConstraintDataChanged();
+    }
+    private void ConstraintData_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IRun> e) {
+      base.OnConstraintDataChanged();
+    }
+    private void ConstraintData_CollectionReset(object sender, CollectionItemsChangedEventArgs<IRun> e) {
+      base.OnConstraintDataChanged();
+    }
+
+    protected override bool Check(object constrainedMember) {
+      if (!Active) return true;
+
+      foreach (IRun run in ConstrainedValue.Where(r => r.Visible))
+        run.Visible = !ConstraintData.Contains(run);
+      return true;
+    }
+
+    protected override bool Check(object constrainedMember, out string errorMessage) {
+      errorMessage = string.Empty;
+      if (!Active) return true;
+
+      foreach (IRun run in ConstrainedValue.Where(r => r.Visible))
+        run.Visible = !ConstraintData.Contains(run);
+      return true;
+    }
+  }
+}
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionEqualityConstraint.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionEqualityConstraint.cs	(revision 6674)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionEqualityConstraint.cs	(revision 6675)
@@ -30,5 +30,5 @@
   [StorableClass]
   [Item("RunCollectionEqualityConstraint", "A constraint which checks the members of the contained runs for equality to the constraint data.")]
-  public class RunCollectionEqualityConstraint : EqualityConstraint, IRunCollectionConstraint {
+  public class RunCollectionEqualityConstraint : EqualityConstraint, IRunCollectionColumnConstraint {
     [StorableConstructor]
     protected RunCollectionEqualityConstraint(bool deserializing) : base(deserializing) { }
Index: /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionTypeCompatiblityConstraint.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionTypeCompatiblityConstraint.cs	(revision 6674)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Optimization/3.3/RunCollectionConstraints/RunCollectionTypeCompatiblityConstraint.cs	(revision 6675)
@@ -30,5 +30,5 @@
   [StorableClass]
   [Item("RunCollectionTypeCompatibilityConstraint", "A constraint which checks the members of the contained runs for type compabitiliby to the constraint data.")]
-  public class RunCollectionTypeCompatibilityConstraint : TypeCompatibilityConstraint, IRunCollectionConstraint {
+  public class RunCollectionTypeCompatibilityConstraint : TypeCompatibilityConstraint, IRunCollectionColumnConstraint {
     [StorableConstructor]
     protected RunCollectionTypeCompatibilityConstraint(bool deserializing) {
